Iot Hub Resource - Create Or Update

Create or update the metadata of an Iot hub. The usual pattern to modify a property is to retrieve the IoT hub metadata and security metadata, and then combine them with the modified values in a new body to update the IoT hub.

PUT https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Devices/IotHubs/{resourceName}?api-version=2026-11-01

URI Parameters

Name In Required Type Description
resourceGroupName
path True

string

minLength: 1
maxLength: 90

The name of the resource group. The name is case insensitive.

resourceName
path True

string

The name of the IoT hub.

subscriptionId
path True

string (uuid)

The ID of the target subscription. The value must be an UUID.

api-version
query True

string

minLength: 1

The API version to use for this operation.

Request Header

Name Required Type Description
If-Match

string

ETag of the IoT Hub. Do not specify for creating a brand new IoT Hub. Required to update an existing IoT Hub.

Request Body

Name Required Type Description
location True

string

The geo-location where the resource lives

sku True

IotHubSkuInfo

IotHub SKU info

etag

string

The Etag field is not required. If it is provided in the response body, it must also be provided as a header per the normal ETag convention.

identity

ArmIdentity

The managed identities for the IotHub.

properties

IotHubProperties

IotHub properties

tags

object

Resource tags.

Responses

Name Type Description
200 OK

IotHubDescription

Resource 'IotHubDescription' update operation succeeded

201 Created

IotHubDescription

Resource 'IotHubDescription' create operation succeeded

Headers

  • Azure-AsyncOperation: string
  • Retry-After: integer
Other Status Codes

ErrorDetails

An unexpected error response.

Security

azure_auth

Azure Active Directory OAuth2 Flow.

Type: oauth2
Flow: implicit
Authorization URL: https://login.microsoftonline.com/common/oauth2/authorize

Scopes

Name Description
user_impersonation impersonate your user account

Examples

CreateOrReplace_IotHub
IotHubResource_CreateOrUpdate

CreateOrReplace_IotHub

Sample request

PUT https://management.azure.com/subscriptions/91d12660-3dec-467a-be2a-213b5544ddc0/resourceGroups/myResourceGroup/providers/Microsoft.Devices/IotHubs/testHub?api-version=2026-11-01

{
  "location": "centraluseuap",
  "tags": {},
  "etag": "AAAAAAFD6M4=",
  "properties": {
    "ipFilterRules": [],
    "networkRuleSets": {
      "defaultAction": "Deny",
      "applyToBuiltInEventHubEndpoint": true,
      "ipRules": [
        {
          "filterName": "rule1",
          "action": "Allow",
          "ipMask": "131.117.159.53"
        },
        {
          "filterName": "rule2",
          "action": "Allow",
          "ipMask": "157.55.59.128/25"
        }
      ]
    },
    "eventHubEndpoints": {
      "events": {
        "retentionTimeInDays": 1,
        "partitionCount": 2
      }
    },
    "routing": {
      "endpoints": {
        "serviceBusQueues": [],
        "serviceBusTopics": [],
        "eventHubs": [],
        "storageContainers": []
      },
      "routes": [
        {
          "name": "Routeid",
          "source": "DeviceMessages",
          "condition": "true",
          "endpointNames": [
            "events"
          ],
          "isEnabled": true
        }
      ],
      "fallbackRoute": {
        "name": "$fallback",
        "source": "DeviceMessages",
        "condition": "true",
        "endpointNames": [
          "events"
        ],
        "isEnabled": true
      }
    },
    "storageEndpoints": {
      "$default": {
        "sasTtlAsIso8601": "PT1H",
        "connectionString": "",
        "containerName": ""
      }
    },
    "messagingEndpoints": {
      "fileNotifications": {
        "lockDurationAsIso8601": "PT1M",
        "ttlAsIso8601": "PT1H",
        "maxDeliveryCount": 10
      }
    },
    "enableFileUploadNotifications": false,
    "cloudToDevice": {
      "maxDeliveryCount": 10,
      "defaultTtlAsIso8601": "PT1H",
      "feedback": {
        "lockDurationAsIso8601": "PT1M",
        "ttlAsIso8601": "PT1H",
        "maxDeliveryCount": 10
      }
    },
    "features": "None",
    "minTlsVersion": "1.2",
    "enableDataResidency": true
  },
  "sku": {
    "name": "S1",
    "capacity": 1
  }
}

Sample response

{
  "id": "/subscriptions/ae24ff83-d2ca-4fc8-9717-05dae4bba489/resourceGroups/myResourceGroup/providers/Microsoft.Devices/IotHubs/testHub",
  "name": "testHub",
  "type": "Microsoft.Devices/IotHubs",
  "location": "centraluseuap",
  "tags": {},
  "etag": "AAAAAAFD6M4=",
  "properties": {
    "state": "Active",
    "provisioningState": "Succeeded",
    "ipFilterRules": [
      {
        "filterName": "rule1",
        "action": "Accept",
        "ipMask": "131.117.159.53"
      },
      {
        "filterName": "rule2",
        "action": "Accept",
        "ipMask": "157.55.59.128/25"
      }
    ],
    "networkRuleSets": {
      "defaultAction": "Deny",
      "applyToBuiltInEventHubEndpoint": true,
      "ipRules": [
        {
          "filterName": "rule1",
          "action": "Allow",
          "ipMask": "131.117.159.53"
        },
        {
          "filterName": "rule2",
          "action": "Allow",
          "ipMask": "157.55.59.128/25"
        }
      ]
    },
    "hostName": "iot-dps-cit-hub-1.azure-devices.net",
    "deviceHostName": "iot-dps-cit-hub-1.device.azure-devices.net",
    "serviceHostName": "iot-dps-cit-hub-1.service.azure-devices.net",
    "eventHubEndpoints": {
      "events": {
        "retentionTimeInDays": 1,
        "partitionCount": 2,
        "partitionIds": [
          "0",
          "1"
        ],
        "path": "iot-dps-cit-hub-1",
        "endpoint": "sb://iothub-ns-iot-dps-ci-245306-76aca8e13b.servicebus.windows.net/"
      }
    },
    "routing": {
      "endpoints": {
        "serviceBusQueues": [],
        "serviceBusTopics": [],
        "eventHubs": [],
        "storageContainers": []
      },
      "routes": [
        {
          "name": "Routeid",
          "source": "DeviceMessages",
          "condition": "true",
          "endpointNames": [
            "events"
          ],
          "isEnabled": true
        }
      ],
      "fallbackRoute": {
        "name": "$fallback",
        "source": "DeviceMessages",
        "condition": "true",
        "endpointNames": [
          "events"
        ],
        "isEnabled": true
      }
    },
    "storageEndpoints": {
      "$default": {
        "sasTtlAsIso8601": "PT1H",
        "connectionString": "",
        "containerName": ""
      }
    },
    "messagingEndpoints": {
      "fileNotifications": {
        "lockDurationAsIso8601": "PT1M",
        "ttlAsIso8601": "PT1H",
        "maxDeliveryCount": 10
      }
    },
    "enableFileUploadNotifications": false,
    "cloudToDevice": {
      "maxDeliveryCount": 10,
      "defaultTtlAsIso8601": "PT1H",
      "feedback": {
        "lockDurationAsIso8601": "PT1M",
        "ttlAsIso8601": "PT1H",
        "maxDeliveryCount": 10
      }
    },
    "features": "None",
    "minTlsVersion": "1.2",
    "enableDataResidency": true,
    "iotHubDetails": {
      "gatewayVersion": "V2"
    }
  },
  "sku": {
    "name": "S1",
    "tier": "Standard",
    "capacity": 1
  },
  "systemData": {
    "createdAt": "2021-01-30T00:28:38.963Z"
  }
}
{
  "id": "/subscriptions/ae24ff83-d2ca-4fc8-9717-05dae4bba489/resourceGroups/myResourceGroup/providers/Microsoft.Devices/IotHubs/testHub",
  "name": "testHub",
  "type": "Microsoft.Devices/IotHubs",
  "location": "centraluseuap",
  "tags": {},
  "etag": "AAAAAAFD6M4=",
  "properties": {
    "state": "Active",
    "provisioningState": "Succeeded",
    "ipFilterRules": [
      {
        "filterName": "rule1",
        "action": "Accept",
        "ipMask": "131.117.159.53"
      },
      {
        "filterName": "rule2",
        "action": "Accept",
        "ipMask": "157.55.59.128/25"
      }
    ],
    "networkRuleSets": {
      "defaultAction": "Deny",
      "applyToBuiltInEventHubEndpoint": true,
      "ipRules": [
        {
          "filterName": "rule1",
          "action": "Allow",
          "ipMask": "131.117.159.53"
        },
        {
          "filterName": "rule2",
          "action": "Allow",
          "ipMask": "157.55.59.128/25"
        }
      ]
    },
    "hostName": "iot-dps-cit-hub-1.azure-devices.net",
    "deviceHostName": "iot-dps-cit-hub-1.device.azure-devices.net",
    "serviceHostName": "iot-dps-cit-hub-1.service.azure-devices.net",
    "eventHubEndpoints": {
      "events": {
        "retentionTimeInDays": 1,
        "partitionCount": 2,
        "partitionIds": [
          "0",
          "1"
        ],
        "path": "iot-dps-cit-hub-1",
        "endpoint": "sb://iothub-ns-iot-dps-ci-245306-76aca8e13b.servicebus.windows.net/"
      }
    },
    "routing": {
      "endpoints": {
        "serviceBusQueues": [],
        "serviceBusTopics": [],
        "eventHubs": [],
        "storageContainers": []
      },
      "routes": [
        {
          "name": "Routeid",
          "source": "DeviceMessages",
          "condition": "true",
          "endpointNames": [
            "events"
          ],
          "isEnabled": true
        }
      ],
      "fallbackRoute": {
        "name": "$fallback",
        "source": "DeviceMessages",
        "condition": "true",
        "endpointNames": [
          "events"
        ],
        "isEnabled": true
      }
    },
    "storageEndpoints": {
      "$default": {
        "sasTtlAsIso8601": "PT1H",
        "connectionString": "",
        "containerName": ""
      }
    },
    "messagingEndpoints": {
      "fileNotifications": {
        "lockDurationAsIso8601": "PT1M",
        "ttlAsIso8601": "PT1H",
        "maxDeliveryCount": 10
      }
    },
    "enableFileUploadNotifications": false,
    "cloudToDevice": {
      "maxDeliveryCount": 10,
      "defaultTtlAsIso8601": "PT1H",
      "feedback": {
        "lockDurationAsIso8601": "PT1M",
        "ttlAsIso8601": "PT1H",
        "maxDeliveryCount": 10
      }
    },
    "features": "None",
    "minTlsVersion": "1.2",
    "enableDataResidency": true,
    "iotHubDetails": {
      "gatewayVersion": "V2"
    }
  },
  "sku": {
    "name": "S1",
    "tier": "Standard",
    "capacity": 1
  },
  "systemData": {
    "createdAt": "2021-01-30T00:28:38.963Z"
  }
}

IotHubResource_CreateOrUpdate

Sample request

PUT https://management.azure.com/subscriptions/91d12660-3dec-467a-be2a-213b5544ddc0/resourceGroups/myResourceGroup/providers/Microsoft.Devices/IotHubs/testHub?api-version=2026-11-01

{
  "etag": "AAAAAAFD6M4=",
  "location": "centraluseuap",
  "identity": {
    "type": "SystemAssigned"
  },
  "properties": {
    "cloudToDevice": {
      "defaultTtlAsIso8601": "PT1H",
      "feedback": {
        "lockDurationAsIso8601": "PT1M",
        "maxDeliveryCount": 10,
        "ttlAsIso8601": "PT1H"
      },
      "maxDeliveryCount": 10
    },
    "enableDataResidency": true,
    "enableFileUploadNotifications": false,
    "eventHubEndpoints": {
      "events": {
        "partitionCount": 2,
        "retentionTimeInDays": 1
      }
    },
    "features": "None",
    "ipFilterRules": [],
    "messagingEndpoints": {
      "fileNotifications": {
        "lockDurationAsIso8601": "PT1M",
        "maxDeliveryCount": 10,
        "ttlAsIso8601": "PT1H"
      }
    },
    "minTlsVersion": "1.2",
    "networkRuleSets": {
      "applyToBuiltInEventHubEndpoint": true,
      "defaultAction": "Deny",
      "ipRules": [
        {
          "action": "Allow",
          "filterName": "rule1",
          "ipMask": "131.117.159.53"
        },
        {
          "action": "Allow",
          "filterName": "rule2",
          "ipMask": "157.55.59.128/25"
        }
      ]
    },
    "routing": {
      "endpoints": {
        "eventHubs": [],
        "serviceBusQueues": [],
        "serviceBusTopics": [],
        "storageContainers": [],
        "eventStreams": [
          {
            "name": "eventstreamendpoint1",
            "endpointUri": "sb://eventstreamcustomsourceehns.azure.servicebus.net",
            "entityPath": "eventstreamcustomsourceeh",
            "authenticationType": "identityBased",
            "workspaceId": "11111111-1111-1111-1111-111111111111",
            "eventStreamId": "22222222-2222-2222-2222-222222222222",
            "sourceId": "33333333-3333-3333-3333-333333333333"
          }
        ]
      },
      "fallbackRoute": {
        "name": "$fallback",
        "condition": "true",
        "endpointNames": [
          "events"
        ],
        "isEnabled": true,
        "source": "DeviceMessages"
      },
      "routes": []
    },
    "storageEndpoints": {
      "$default": {
        "connectionString": "",
        "containerName": "",
        "sasTtlAsIso8601": "PT1H"
      }
    }
  },
  "sku": {
    "name": "S1",
    "capacity": 1
  },
  "tags": {}
}

Sample response

{
  "name": "testHub",
  "type": "Microsoft.Devices/IotHubs",
  "etag": "AAAAAAFD6M4=",
  "id": "/subscriptions/ae24ff83-d2ca-4fc8-9717-05dae4bba489/resourceGroups/myResourceGroup/providers/Microsoft.Devices/IotHubs/testHub",
  "location": "centraluseuap",
  "identity": {
    "tenantId": "11111111-2222-3333-4444-555555555555",
    "type": "SystemAssigned",
    "principalId": "66666666-7777-8888-9999-aaaaaaaaaaaa"
  },
  "properties": {
    "cloudToDevice": {
      "defaultTtlAsIso8601": "PT1H",
      "feedback": {
        "lockDurationAsIso8601": "PT1M",
        "maxDeliveryCount": 10,
        "ttlAsIso8601": "PT1H"
      },
      "maxDeliveryCount": 10
    },
    "enableDataResidency": true,
    "enableFileUploadNotifications": false,
    "eventHubEndpoints": {
      "events": {
        "path": "iot-dps-cit-hub-1",
        "endpoint": "sb://iothub-ns-iot-dps-ci-245306-76aca8e13b.servicebus.windows.net/",
        "partitionCount": 2,
        "partitionIds": [
          "0",
          "1"
        ],
        "retentionTimeInDays": 1
      }
    },
    "features": "None",
    "hostName": "iot-dps-cit-hub-1.azure-devices.net",
    "ipFilterRules": [
      {
        "action": "Accept",
        "filterName": "rule1",
        "ipMask": "131.117.159.53"
      },
      {
        "action": "Accept",
        "filterName": "rule2",
        "ipMask": "157.55.59.128/25"
      }
    ],
    "messagingEndpoints": {
      "fileNotifications": {
        "lockDurationAsIso8601": "PT1M",
        "maxDeliveryCount": 10,
        "ttlAsIso8601": "PT1H"
      }
    },
    "minTlsVersion": "1.2",
    "networkRuleSets": {
      "applyToBuiltInEventHubEndpoint": true,
      "defaultAction": "Deny",
      "ipRules": [
        {
          "action": "Allow",
          "filterName": "rule1",
          "ipMask": "131.117.159.53"
        },
        {
          "action": "Allow",
          "filterName": "rule2",
          "ipMask": "157.55.59.128/25"
        }
      ]
    },
    "provisioningState": "Succeeded",
    "routing": {
      "endpoints": {
        "eventHubs": [],
        "serviceBusQueues": [],
        "serviceBusTopics": [],
        "storageContainers": [],
        "eventStreams": [
          {
            "name": "eventstreamendpoint1",
            "id": "00000000-1111-2222-3333-0123456789ab",
            "endpointUri": "sb://eventstreamcustomsourceehns.azure.servicebus.net",
            "entityPath": "eventstreamcustomsourceeh",
            "authenticationType": "identityBased",
            "workspaceId": "11111111-1111-1111-1111-111111111111",
            "eventStreamId": "22222222-2222-2222-2222-222222222222",
            "sourceId": "33333333-3333-3333-3333-333333333333"
          }
        ]
      },
      "fallbackRoute": {
        "name": "$fallback",
        "condition": "true",
        "endpointNames": [
          "events"
        ],
        "isEnabled": true,
        "source": "DeviceMessages"
      },
      "routes": []
    },
    "state": "Active",
    "storageEndpoints": {
      "$default": {
        "connectionString": "",
        "containerName": "",
        "sasTtlAsIso8601": "PT1H"
      }
    }
  },
  "sku": {
    "name": "S1",
    "capacity": 1,
    "tier": "Standard"
  },
  "systemData": {
    "createdAt": "2021-01-30T00:28:38.963Z"
  },
  "tags": {}
}
{
  "name": "testHub",
  "type": "Microsoft.Devices/IotHubs",
  "etag": "AAAAAAFD6M4=",
  "id": "/subscriptions/ae24ff83-d2ca-4fc8-9717-05dae4bba489/resourceGroups/myResourceGroup/providers/Microsoft.Devices/IotHubs/testHub",
  "location": "centraluseuap",
  "identity": {
    "tenantId": "11111111-2222-3333-4444-555555555555",
    "type": "SystemAssigned",
    "principalId": "66666666-7777-8888-9999-aaaaaaaaaaaa"
  },
  "properties": {
    "cloudToDevice": {
      "defaultTtlAsIso8601": "PT1H",
      "feedback": {
        "lockDurationAsIso8601": "PT1M",
        "maxDeliveryCount": 10,
        "ttlAsIso8601": "PT1H"
      },
      "maxDeliveryCount": 10
    },
    "enableDataResidency": true,
    "enableFileUploadNotifications": false,
    "eventHubEndpoints": {
      "events": {
        "path": "iot-dps-cit-hub-1",
        "endpoint": "sb://iothub-ns-iot-dps-ci-245306-76aca8e13b.servicebus.windows.net/",
        "partitionCount": 2,
        "partitionIds": [
          "0",
          "1"
        ],
        "retentionTimeInDays": 1
      }
    },
    "features": "None",
    "hostName": "iot-dps-cit-hub-1.azure-devices.net",
    "ipFilterRules": [
      {
        "action": "Accept",
        "filterName": "rule1",
        "ipMask": "131.117.159.53"
      },
      {
        "action": "Accept",
        "filterName": "rule2",
        "ipMask": "157.55.59.128/25"
      }
    ],
    "messagingEndpoints": {
      "fileNotifications": {
        "lockDurationAsIso8601": "PT1M",
        "maxDeliveryCount": 10,
        "ttlAsIso8601": "PT1H"
      }
    },
    "minTlsVersion": "1.2",
    "networkRuleSets": {
      "applyToBuiltInEventHubEndpoint": true,
      "defaultAction": "Deny",
      "ipRules": [
        {
          "action": "Allow",
          "filterName": "rule1",
          "ipMask": "131.117.159.53"
        },
        {
          "action": "Allow",
          "filterName": "rule2",
          "ipMask": "157.55.59.128/25"
        }
      ]
    },
    "provisioningState": "Succeeded",
    "routing": {
      "endpoints": {
        "eventHubs": [],
        "serviceBusQueues": [],
        "serviceBusTopics": [],
        "storageContainers": [],
        "eventStreams": [
          {
            "name": "eventstreamendpoint1",
            "id": "00000000-1111-2222-3333-0123456789ab",
            "endpointUri": "sb://eventstreamcustomsourceehns.azure.servicebus.net",
            "entityPath": "eventstreamcustomsourceeh",
            "authenticationType": "identityBased",
            "workspaceId": "11111111-1111-1111-1111-111111111111",
            "eventStreamId": "22222222-2222-2222-2222-222222222222",
            "sourceId": "33333333-3333-3333-3333-333333333333"
          }
        ]
      },
      "fallbackRoute": {
        "name": "$fallback",
        "condition": "true",
        "endpointNames": [
          "events"
        ],
        "isEnabled": true,
        "source": "DeviceMessages"
      },
      "routes": []
    },
    "state": "Active",
    "storageEndpoints": {
      "$default": {
        "connectionString": "",
        "containerName": "",
        "sasTtlAsIso8601": "PT1H"
      }
    }
  },
  "sku": {
    "name": "S1",
    "capacity": 1,
    "tier": "Standard"
  },
  "systemData": {
    "createdAt": "2021-01-30T00:28:38.963Z"
  },
  "tags": {}
}

Definitions

Name Description
AccessRights

The permissions assigned to the shared access policy.

ArmIdentity
ArmUserIdentity
AuthenticationType

Specifies authentication type being used for connecting to the storage account.

Capabilities

The capabilities and features enabled for the IoT hub.

CloudToDeviceProperties

The IoT hub cloud-to-device messaging properties.

createdByType

The type of identity that created the resource.

DefaultAction

Default Action for Network Rule Set

DeviceRegistry

Represents properties related to the Azure Device Registry (ADR).

DeviceRegistryIdentity

The identity used to manage the ADR namespace from the data plane.

DeviceRegistryIdentityType

The type of the identity.

DeviceRegistryLinkingProperties

The properties related to linking the IoT Hub with the Azure Device Registry.

DeviceRegistryLinkingState

Indicates whether the IoT Hub is linked with an Azure Device Registry.

EnrichmentProperties

The properties of an enrichment that your IoT hub applies to messages delivered to endpoints.

ErrorDetails

Error details.

EventHubProperties

The properties of the provisioned Event Hub-compatible endpoint used by the IoT hub.

EventStreamAuthenticationType

Specifies authentication type being used for connecting to the event stream account.

FallbackRouteProperties

The properties of the fallback route. IoT Hub uses these properties when it routes messages to the fallback endpoint.

FallbackRouteSource

The source to which the fallback route is applied.

FeedbackProperties

The properties of the feedback queue for cloud-to-device messages.

GatewayVersion

The IoT hub Gateway version.

IotHubDescription

The description of the IoT hub.

IotHubDetails

Set of additional read-only properties for the IoT hub.

IotHubLocationDescription

Public representation of one of the locations where a resource is provisioned.

IotHubProperties

The properties of an IoT hub.

IotHubReplicaRoleType

The role of the region, can be either primary or secondary. The primary region is where the IoT hub is currently provisioned. The secondary region is the Azure disaster recovery (DR) paired region and also the region where the IoT hub can failover to.

IotHubSku

The name of the SKU.

IotHubSkuInfo

Information about the SKU of the IoT hub.

IotHubSkuTier

The billing tier for the IoT hub.

IpFilterActionType

The desired action for requests captured by this rule.

IpFilterRule

The IP filter rules for the IoT hub.

ManagedIdentity

The properties of the Managed identity.

MessagingEndpointProperties

The properties of the messaging endpoints used by this IoT hub.

NetworkRuleIPAction

IP Filter Action

NetworkRuleSetIpRule

IP Rule to be applied as part of Network Rule Set

NetworkRuleSetProperties

Network Rule Set Properties of IotHub

PrivateEndpoint

The private endpoint property of a private endpoint connection

PrivateEndpointConnection

The private endpoint connection of an IotHub

PrivateEndpointConnectionProperties

The properties of a private endpoint connection

PrivateLinkServiceConnectionState

The current state of a private endpoint connection

PrivateLinkServiceConnectionStatus

The status of a private endpoint connection

PublicNetworkAccess

Whether requests from Public Network are allowed

ResourceIdentityType

The type of identity used for the resource. The type 'SystemAssigned,UserAssigned' includes both an implicitly created identity and a set of user assigned identities. The type 'None' will remove any identities from the service.

RouteProperties

The properties of a routing rule that your IoT hub uses to route messages to endpoints.

RoutingCosmosDBSqlApiProperties

The properties related to a cosmos DB sql container endpoint.

RoutingEndpoints

The properties related to the custom endpoints to which your IoT hub routes messages based on the routing rules. A maximum of 10 custom endpoints are allowed across all endpoint types for paid hubs and only 1 custom endpoint is allowed across all endpoint types for free hubs.

RoutingEventHubProperties

The properties related to an event hub endpoint.

RoutingEventStreamProperties

The properties related to an event stream endpoint.

RoutingProperties

The routing related properties of the IoT hub. See: https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-messaging

RoutingServiceBusQueueEndpointProperties

The properties related to service bus queue endpoint types.

RoutingServiceBusTopicEndpointProperties

The properties related to service bus topic endpoint types.

RoutingSource

The source that the routing rule is to be applied to, such as DeviceMessages.

RoutingStorageContainerProperties

The properties related to a storage container endpoint.

RoutingStorageContainerPropertiesEncoding

Encoding that is used to serialize messages to blobs. Supported values are 'avro', 'avrodeflate', and 'JSON'. Default value is 'avro'.

SharedAccessSignatureAuthorizationRule

The properties of an IoT hub shared access policy.

StorageEndpointProperties

The properties of the Azure Storage endpoint for file upload.

systemData

Metadata pertaining to creation and last modification of the resource.

AccessRights

The permissions assigned to the shared access policy.

Value Description
RegistryRead

RegistryRead

RegistryWrite

RegistryWrite

ServiceConnect

ServiceConnect

DeviceConnect

DeviceConnect

RegistryRead, RegistryWrite

RegistryRead, RegistryWrite

RegistryRead, ServiceConnect

RegistryRead, ServiceConnect

RegistryRead, DeviceConnect

RegistryRead, DeviceConnect

RegistryWrite, ServiceConnect

RegistryWrite, ServiceConnect

RegistryWrite, DeviceConnect

RegistryWrite, DeviceConnect

ServiceConnect, DeviceConnect

ServiceConnect, DeviceConnect

RegistryRead, RegistryWrite, ServiceConnect

RegistryRead, RegistryWrite, ServiceConnect

RegistryRead, RegistryWrite, DeviceConnect

RegistryRead, RegistryWrite, DeviceConnect

RegistryRead, ServiceConnect, DeviceConnect

RegistryRead, ServiceConnect, DeviceConnect

RegistryWrite, ServiceConnect, DeviceConnect

RegistryWrite, ServiceConnect, DeviceConnect

RegistryRead, RegistryWrite, ServiceConnect, DeviceConnect

RegistryRead, RegistryWrite, ServiceConnect, DeviceConnect

ArmIdentity

Name Type Description
principalId

string

Principal Id

tenantId

string

Tenant Id

type

ResourceIdentityType

The type of identity used for the resource. The type 'SystemAssigned,UserAssigned' includes both an implicitly created identity and a set of user assigned identities. The type 'None' will remove any identities from the service.

userAssignedIdentities

<string,  ArmUserIdentity>

Dictionary of <ArmUserIdentity>

ArmUserIdentity

Name Type Description
clientId

string

principalId

string

AuthenticationType

Specifies authentication type being used for connecting to the storage account.

Value Description
keyBased

keyBased

identityBased

identityBased

Capabilities

The capabilities and features enabled for the IoT hub.

Value Description
None

None

DeviceManagement

DeviceManagement

CloudToDeviceProperties

The IoT hub cloud-to-device messaging properties.

Name Type Description
defaultTtlAsIso8601

string (duration)

The default time to live for cloud-to-device messages in the device queue. See: https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-messaging#cloud-to-device-messages.

feedback

FeedbackProperties

The properties of the feedback queue for cloud-to-device messages.

maxDeliveryCount

integer (int32)

minimum: 1
maximum: 100

The max delivery count for cloud-to-device messages in the device queue. See: https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-messaging#cloud-to-device-messages.

createdByType

The type of identity that created the resource.

Value Description
User
Application
ManagedIdentity
Key

DefaultAction

Default Action for Network Rule Set

Value Description
Deny

Deny

Allow

Allow

DeviceRegistry

Represents properties related to the Azure Device Registry (ADR).

Name Type Description
dataPlaneHostName

string

The host name for the data plane endpoint of the associated Azure Device Registry.

identity

DeviceRegistryIdentity

The identity used to manage the ADR namespace from the data plane.

linkingProperties

DeviceRegistryLinkingProperties

The properties related to linking the IoT Hub with the Azure Device Registry.

namespaceResourceId

string (arm-id)

The identifier of the Azure Device Registry namespace

namespaceUuid

string

The UUID of the associated Azure Device Registry namespace.

DeviceRegistryIdentity

The identity used to manage the ADR namespace from the data plane.

Name Type Description
type

DeviceRegistryIdentityType

The type of the identity.

userAssignedIdentity

string (arm-id)

The user assigned identity if the identity type is 'UserAssigned'.

DeviceRegistryIdentityType

The type of the identity.

Value Description
SystemAssigned

Use a system-assigned managed identity to manage the ADR namespace.

UserAssigned

Use a user-assigned managed identity to manage the ADR namespace.

DeviceRegistryLinkingProperties

The properties related to linking the IoT Hub with the Azure Device Registry.

Name Type Description
error

ErrorDetails

The last error encountered when linking the IoT Hub with an Azure Device Registry.

state

DeviceRegistryLinkingState

Indicates whether the IoT Hub is linked with an Azure Device Registry.

DeviceRegistryLinkingState

Indicates whether the IoT Hub is linked with an Azure Device Registry.

Value Description
InProgress

The IoT Hub linking with an Azure Device Registry is in progress.

Success

The IoT Hub is successfully linked with an Azure Device Registry.

Orphaned

The linked Azure Device Registry is no longer associated with the IoT Hub.

Failed

The IoT Hub failed to link with an Azure Device Registry.

EnrichmentProperties

The properties of an enrichment that your IoT hub applies to messages delivered to endpoints.

Name Type Description
endpointNames

string[]

The list of endpoints for which the enrichment is applied to the message.

key

string

The key or name for the enrichment property.

value

string

The value for the enrichment property.

ErrorDetails

Error details.

Name Type Description
code

string

The error code.

details

string

The error details.

httpStatusCode

string

The HTTP status code.

message

string

The error message.

EventHubProperties

The properties of the provisioned Event Hub-compatible endpoint used by the IoT hub.

Name Type Description
endpoint

string

The Event Hub-compatible endpoint.

partitionCount

integer (int32)

The number of partitions for receiving device-to-cloud messages in the Event Hub-compatible endpoint. See: https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-messaging#device-to-cloud-messages.

partitionIds

string[]

The partition ids in the Event Hub-compatible endpoint.

path

string

The Event Hub-compatible name.

retentionTimeInDays

integer (int64)

The retention time for device-to-cloud messages in days. See: https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-messaging#device-to-cloud-messages

EventStreamAuthenticationType

Specifies authentication type being used for connecting to the event stream account.

Value Description
identityBased

identityBased authentication

FallbackRouteProperties

The properties of the fallback route. IoT Hub uses these properties when it routes messages to the fallback endpoint.

Name Type Description
condition

string

The condition which is evaluated in order to apply the fallback route. If the condition is not provided it will evaluate to true by default. For grammar, See: https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-query-language

endpointNames

string[]

The list of endpoints to which the messages that satisfy the condition are routed to. Currently only 1 endpoint is allowed.

isEnabled

boolean

Used to specify whether the fallback route is enabled.

name

string

The name of the route. The name can only include alphanumeric characters, periods, underscores, hyphens, has a maximum length of 64 characters, and must be unique.

source

FallbackRouteSource

The source to which the routing rule is to be applied to. For example, DeviceMessages

FallbackRouteSource

The source to which the fallback route is applied.

Value Description
DeviceMessages

Device-to-cloud messages sent by devices.

FeedbackProperties

The properties of the feedback queue for cloud-to-device messages.

Name Type Description
lockDurationAsIso8601

string (duration)

The lock duration for the feedback queue. See: https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-messaging#cloud-to-device-messages.

maxDeliveryCount

integer (int32)

minimum: 1
maximum: 100

The number of times the IoT hub attempts to deliver a message on the feedback queue. See: https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-messaging#cloud-to-device-messages.

ttlAsIso8601

string (duration)

The period of time for which a message is available to consume before it is expired by the IoT hub. See: https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-messaging#cloud-to-device-messages.

GatewayVersion

The IoT hub Gateway version.

Value Description
V1

V1

V2

V2

IotHubDescription

The description of the IoT hub.

Name Type Description
etag

string

The Etag field is not required. If it is provided in the response body, it must also be provided as a header per the normal ETag convention.

id

string (arm-id)

Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"

identity

ArmIdentity

The managed identities for the IotHub.

location

string

The geo-location where the resource lives

name

string

The name of the resource

properties

IotHubProperties

IotHub properties

sku

IotHubSkuInfo

IotHub SKU info

systemData

systemData

Azure Resource Manager metadata containing createdBy and modifiedBy information.

tags

object

Resource tags.

type

string

The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"

IotHubDetails

Set of additional read-only properties for the IoT hub.

Name Type Description
gatewayVersion

GatewayVersion

The IoT hub Gateway version.

IotHubLocationDescription

Public representation of one of the locations where a resource is provisioned.

Name Type Description
location

string

The name of the Azure region

role

IotHubReplicaRoleType

The role of the region, can be either primary or secondary. The primary region is where the IoT hub is currently provisioned. The secondary region is the Azure disaster recovery (DR) paired region and also the region where the IoT hub can failover to.

IotHubProperties

The properties of an IoT hub.

Name Type Description
allowedFqdnList

string[]

List of allowed FQDNs(Fully Qualified Domain Name) for egress from Iot Hub.

authorizationPolicies

SharedAccessSignatureAuthorizationRule[]

The shared access policies you can use to secure a connection to the IoT hub.

cloudToDevice

CloudToDeviceProperties

The IoT hub cloud-to-device messaging properties.

comments

string

IoT hub comments.

deviceHostName

string

The name of the device host. Supports secure connections over TLS 1.3.

deviceRegistry

DeviceRegistry

Represents properties related to the Azure Device Registry (ADR).

disableDeviceSAS

boolean

If true, all device(including Edge devices but excluding modules) scoped SAS keys cannot be used for authentication.

disableLocalAuth

boolean

If true, SAS tokens with Iot hub scoped SAS keys cannot be used for authentication.

disableModuleSAS

boolean

If true, all module scoped SAS keys cannot be used for authentication.

enableDataResidency

boolean

This property when set to true, will enable data residency, thus, disabling disaster recovery.

enableFileUploadNotifications

boolean

If True, file upload notifications are enabled.

eventHubEndpoints

<string,  EventHubProperties>

The Event Hub-compatible endpoint properties. The only possible keys to this dictionary is events. This key has to be present in the dictionary while making create or update calls for the IoT hub.

features

Capabilities

The capabilities and features enabled for the IoT hub.

hostName

string

The name of the host.

iotHubDetails

IotHubDetails

Set of additional read-only properties for the IoT hub.

ipFilterRules

IpFilterRule[]

The IP filter rules.

locations

IotHubLocationDescription[]

Primary and secondary location for iot hub

messagingEndpoints

<string,  MessagingEndpointProperties>

The messaging endpoint properties for the file upload notification queue.

minTlsVersion

string

Specifies the minimum TLS version to support for this hub. Can be set to "1.2" to have clients that use a TLS version below 1.2 to be rejected.

networkRuleSets

NetworkRuleSetProperties

Network Rule Set Properties of IotHub

privateEndpointConnections

PrivateEndpointConnection[]

Private endpoint connections created on this IotHub

provisioningState

string

The provisioning state.

publicNetworkAccess

PublicNetworkAccess

Whether requests from Public Network are allowed

restrictOutboundNetworkAccess

boolean

If true, egress from IotHub will be restricted to only the allowed FQDNs that are configured via allowedFqdnList.

routing

RoutingProperties

The routing related properties of the IoT hub. See: https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-messaging

serviceHostName

string

The name of the service host. Supports secure connections over TLS 1.3.

state

string

The hub state.

storageEndpoints

<string,  StorageEndpointProperties>

The list of Azure Storage endpoints where you can upload files. Currently you can configure only one Azure Storage account and that MUST have its key as $default. Specifying more than one storage account causes an error to be thrown. Not specifying a value for this property when the enableFileUploadNotifications property is set to True, causes an error to be thrown.

IotHubReplicaRoleType

The role of the region, can be either primary or secondary. The primary region is where the IoT hub is currently provisioned. The secondary region is the Azure disaster recovery (DR) paired region and also the region where the IoT hub can failover to.

Value Description
primary

primary

secondary

secondary

IotHubSku

The name of the SKU.

Value Description
F1

F1

S1

S1

S2

S2

S3

S3

B1

B1

B2

B2

B3

B3

IotHubSkuInfo

Information about the SKU of the IoT hub.

Name Type Description
capacity

integer (int64)

The number of provisioned IoT Hub units. See: https://docs.microsoft.com/azure/azure-subscription-service-limits#iot-hub-limits.

name

IotHubSku

The name of the SKU.

tier

IotHubSkuTier

The billing tier for the IoT hub.

IotHubSkuTier

The billing tier for the IoT hub.

Value Description
Free

Free

Standard

Standard

Basic

Basic

IpFilterActionType

The desired action for requests captured by this rule.

Value Description
Accept

Accept

Reject

Reject

IpFilterRule

The IP filter rules for the IoT hub.

Name Type Description
action

IpFilterActionType

The desired action for requests captured by this rule.

filterName

string

The name of the IP filter rule.

ipMask

string

A string that contains the IP address range in CIDR notation for the rule.

ManagedIdentity

The properties of the Managed identity.

Name Type Description
userAssignedIdentity

string

The user assigned identity.

MessagingEndpointProperties

The properties of the messaging endpoints used by this IoT hub.

Name Type Description
lockDurationAsIso8601

string (duration)

The lock duration. See: https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-file-upload.

maxDeliveryCount

integer (int32)

minimum: 1
maximum: 100

The number of times the IoT hub attempts to deliver a message. See: https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-file-upload.

ttlAsIso8601

string (duration)

The period of time for which a message is available to consume before it is expired by the IoT hub. See: https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-file-upload.

NetworkRuleIPAction

IP Filter Action

Value Description
Allow

Allow

NetworkRuleSetIpRule

IP Rule to be applied as part of Network Rule Set

Name Type Default value Description
action

NetworkRuleIPAction

Allow

IP Filter Action

filterName

string

Name of the IP filter rule.

ipMask

string

A string that contains the IP address range in CIDR notation for the rule.

NetworkRuleSetProperties

Network Rule Set Properties of IotHub

Name Type Default value Description
applyToBuiltInEventHubEndpoint

boolean

If True, then Network Rule Set is also applied to BuiltIn EventHub EndPoint of IotHub

defaultAction

DefaultAction

Deny

Default Action for Network Rule Set

ipRules

NetworkRuleSetIpRule[]

List of IP Rules

PrivateEndpoint

The private endpoint property of a private endpoint connection

Name Type Description
id

string

The resource identifier.

PrivateEndpointConnection

The private endpoint connection of an IotHub

Name Type Description
id

string (arm-id)

Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"

name

string

The name of the resource

properties

PrivateEndpointConnectionProperties

The properties of a private endpoint connection

systemData

systemData

Azure Resource Manager metadata containing createdBy and modifiedBy information.

type

string

The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"

PrivateEndpointConnectionProperties

The properties of a private endpoint connection

Name Type Description
privateEndpoint

PrivateEndpoint

The private endpoint property of a private endpoint connection

privateLinkServiceConnectionState

PrivateLinkServiceConnectionState

The current state of a private endpoint connection

PrivateLinkServiceConnectionState

The current state of a private endpoint connection

Name Type Description
actionsRequired

string

Actions required for a private endpoint connection

description

string

The description for the current state of a private endpoint connection

status

PrivateLinkServiceConnectionStatus

The status of a private endpoint connection

PrivateLinkServiceConnectionStatus

The status of a private endpoint connection

Value Description
Pending

Pending

Approved

Approved

Rejected

Rejected

Disconnected

Disconnected

PublicNetworkAccess

Whether requests from Public Network are allowed

Value Description
Enabled

Enabled

Disabled

Disabled

ResourceIdentityType

The type of identity used for the resource. The type 'SystemAssigned,UserAssigned' includes both an implicitly created identity and a set of user assigned identities. The type 'None' will remove any identities from the service.

Value Description
SystemAssigned

SystemAssigned

UserAssigned

UserAssigned

SystemAssigned, UserAssigned

SystemAssigned, UserAssigned

None

None

RouteProperties

The properties of a routing rule that your IoT hub uses to route messages to endpoints.

Name Type Description
condition

string

The condition that is evaluated to apply the routing rule. If no condition is provided, it evaluates to true by default. For grammar, see: https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-query-language

endpointNames

string[]

The list of endpoints to which messages that satisfy the condition are routed. Currently only one endpoint is allowed.

isEnabled

boolean

Used to specify whether a route is enabled.

name

string

pattern: ^[A-Za-z0-9-._]{1,64}$

The name of the route. The name can only include alphanumeric characters, periods, underscores, hyphens, has a maximum length of 64 characters, and must be unique.

source

RoutingSource

The source that the routing rule is to be applied to, such as DeviceMessages.

RoutingCosmosDBSqlApiProperties

The properties related to a cosmos DB sql container endpoint.

Name Type Description
authenticationType

AuthenticationType

Method used to authenticate against the cosmos DB sql container endpoint

containerName

string

The name of the cosmos DB sql container in the cosmos DB database.

databaseName

string

The name of the cosmos DB database in the cosmos DB account.

endpointUri

string (uri)

The url of the cosmos DB account. It must include the protocol https://

id

string

Id of the cosmos DB sql container endpoint

identity

ManagedIdentity

Managed identity properties of routing cosmos DB container endpoint.

name

string

pattern: ^[A-Za-z0-9-._]{1,64}$

The name that identifies this endpoint. The name can only include alphanumeric characters, periods, underscores, hyphens and has a maximum length of 64 characters. The following names are reserved: events, fileNotifications, $default. Endpoint names must be unique across endpoint types.

partitionKeyName

string

The name of the partition key associated with this cosmos DB sql container if one exists. This is an optional parameter.

partitionKeyTemplate

string

The template for generating a synthetic partition key value for use with this cosmos DB sql container. The template must include at least one of the following placeholders: {iothub}, {deviceid}, {DD}, {MM}, and {YYYY}. Any one placeholder may be specified at most once, but order and non-placeholder components are arbitrary. This parameter is only required if PartitionKeyName is specified.

primaryKey

string (password)

The primary key of the cosmos DB account.

resourceGroup

string

The name of the resource group of the cosmos DB account.

secondaryKey

string (password)

The secondary key of the cosmos DB account.

subscriptionId

string

The subscription identifier of the cosmos DB account.

RoutingEndpoints

The properties related to the custom endpoints to which your IoT hub routes messages based on the routing rules. A maximum of 10 custom endpoints are allowed across all endpoint types for paid hubs and only 1 custom endpoint is allowed across all endpoint types for free hubs.

Name Type Description
cosmosDBSqlContainers

RoutingCosmosDBSqlApiProperties[]

The list of Cosmos DB container endpoints that IoT hub routes messages to, based on the routing rules.

eventHubs

RoutingEventHubProperties[]

The list of Event Hubs endpoints that IoT hub routes messages to, based on the routing rules. This list does not include the built-in Event Hubs endpoint.

eventStreams

RoutingEventStreamProperties[]

The list of event stream endpoints that IoT hub routes messages to, based on the routing rules.

serviceBusQueues

RoutingServiceBusQueueEndpointProperties[]

The list of Service Bus queue endpoints that IoT hub routes the messages to, based on the routing rules.

serviceBusTopics

RoutingServiceBusTopicEndpointProperties[]

The list of Service Bus topic endpoints that the IoT hub routes the messages to, based on the routing rules.

storageContainers

RoutingStorageContainerProperties[]

The list of storage container endpoints that IoT hub routes messages to, based on the routing rules.

RoutingEventHubProperties

The properties related to an event hub endpoint.

Name Type Description
authenticationType

AuthenticationType

Method used to authenticate against the event hub endpoint

connectionString

string (password)

The connection string of the event hub endpoint.

endpointUri

string

The url of the event hub endpoint. It must include the protocol sb://

entityPath

string

Event hub name on the event hub namespace

id

string

Id of the event hub endpoint

identity

ManagedIdentity

Managed identity properties of routing event hub endpoint.

name

string

pattern: ^[A-Za-z0-9-._]{1,64}$

The name that identifies this endpoint. The name can only include alphanumeric characters, periods, underscores, hyphens and has a maximum length of 64 characters. The following names are reserved: events, fileNotifications, $default. Endpoint names must be unique across endpoint types.

resourceGroup

string

The name of the resource group of the event hub endpoint.

subscriptionId

string

The subscription identifier of the event hub endpoint.

RoutingEventStreamProperties

The properties related to an event stream endpoint.

Name Type Description
authenticationType

EventStreamAuthenticationType

Method used to authenticate against the event stream endpoint

endpointUri

string

The url of the underlying event hub namespace of the event stream endpoint. It must include the protocol sb://

entityPath

string

Event hub name on the event hub namespace

eventStreamId

string

The unique GUID of the target event stream under the workspace.

id

string

Id of the event stream endpoint

identity

ManagedIdentity

Managed identity properties of routing event stream endpoint.

name

string

pattern: ^[A-Za-z0-9-._]{1,64}$

The name that identifies this endpoint. The name can only include alphanumeric characters, periods, underscores, hyphens and has a maximum length of 64 characters. The following names are reserved: events, fileNotifications, $default. Endpoint names must be unique across endpoint types.

sourceId

string

The unique GUID of the custom source for the event stream.

workspaceId

string

The unique GUID of the target Microsoft Fabric workspace for the event stream endpoint.

RoutingProperties

The routing related properties of the IoT hub. See: https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-messaging

Name Type Description
endpoints

RoutingEndpoints

The properties related to the custom endpoints to which your IoT hub routes messages based on the routing rules. A maximum of 10 custom endpoints are allowed across all endpoint types for paid hubs and only 1 custom endpoint is allowed across all endpoint types for free hubs.

enrichments

EnrichmentProperties[]

The list of user-provided enrichments that the IoT hub applies to messages to be delivered to built-in and custom endpoints. See: https://aka.ms/telemetryoneventgrid

fallbackRoute

FallbackRouteProperties

The properties of the route that is used as a fall-back route when none of the conditions specified in the 'routes' section are met. This is an optional parameter. When this property is not set, the messages which do not meet any of the conditions specified in the 'routes' section get routed to the built-in eventhub endpoint.

routes

RouteProperties[]

The list of user-provided routing rules that the IoT hub uses to route messages to built-in and custom endpoints. A maximum of 100 routing rules are allowed for paid hubs and a maximum of 5 routing rules are allowed for free hubs.

RoutingServiceBusQueueEndpointProperties

The properties related to service bus queue endpoint types.

Name Type Description
authenticationType

AuthenticationType

Method used to authenticate against the service bus queue endpoint

connectionString

string (password)

The connection string of the service bus queue endpoint.

endpointUri

string

The url of the service bus queue endpoint. It must include the protocol sb://

entityPath

string

Queue name on the service bus namespace

id

string

Id of the service bus queue endpoint

identity

ManagedIdentity

Managed identity properties of routing service bus queue endpoint.

name

string

pattern: ^[A-Za-z0-9-._]{1,64}$

The name that identifies this endpoint. The name can only include alphanumeric characters, periods, underscores, hyphens and has a maximum length of 64 characters. The following names are reserved: events, fileNotifications, $default. Endpoint names must be unique across endpoint types. The name need not be the same as the actual queue name.

resourceGroup

string

The name of the resource group of the service bus queue endpoint.

subscriptionId

string

The subscription identifier of the service bus queue endpoint.

RoutingServiceBusTopicEndpointProperties

The properties related to service bus topic endpoint types.

Name Type Description
authenticationType

AuthenticationType

Method used to authenticate against the service bus topic endpoint

connectionString

string (password)

The connection string of the service bus topic endpoint.

endpointUri

string

The url of the service bus topic endpoint. It must include the protocol sb://

entityPath

string

Queue name on the service bus topic

id

string

Id of the service bus topic endpoint

identity

ManagedIdentity

Managed identity properties of routing service bus topic endpoint.

name

string

pattern: ^[A-Za-z0-9-._]{1,64}$

The name that identifies this endpoint. The name can only include alphanumeric characters, periods, underscores, hyphens and has a maximum length of 64 characters. The following names are reserved: events, fileNotifications, $default. Endpoint names must be unique across endpoint types. The name need not be the same as the actual topic name.

resourceGroup

string

The name of the resource group of the service bus topic endpoint.

subscriptionId

string

The subscription identifier of the service bus topic endpoint.

RoutingSource

The source that the routing rule is to be applied to, such as DeviceMessages.

Value Description
Invalid

Invalid

DeviceMessages

DeviceMessages

TwinChangeEvents

TwinChangeEvents

DeviceLifecycleEvents

DeviceLifecycleEvents

DeviceJobLifecycleEvents

DeviceJobLifecycleEvents

DeviceConnectionStateEvents

DeviceConnectionStateEvents

RoutingStorageContainerProperties

The properties related to a storage container endpoint.

Name Type Description
authenticationType

AuthenticationType

Method used to authenticate against the storage endpoint

batchFrequencyInSeconds

integer (int32)

minimum: 60
maximum: 720

Time interval at which blobs are written to storage. Value should be between 60 and 720 seconds. Default value is 300 seconds.

connectionString

string (password)

The connection string of the storage account.

containerName

string

The name of storage container in the storage account.

encoding

RoutingStorageContainerPropertiesEncoding

Encoding that is used to serialize messages to blobs. Supported values are 'avro', 'avrodeflate', and 'JSON'. Default value is 'avro'.

endpointUri

string

The url of the storage endpoint. It must include the protocol https://

fileNameFormat

string

File name format for the blob. Default format is {iothub}/{partition}/{YYYY}/{MM}/{DD}/{HH}/{mm}. All parameters are mandatory but can be reordered.

id

string

Id of the storage container endpoint

identity

ManagedIdentity

Managed identity properties of routing storage endpoint.

maxChunkSizeInBytes

integer (int32)

minimum: 10485760
maximum: 524288000

Maximum number of bytes for each blob written to storage. Value should be between 10485760(10MB) and 524288000(500MB). Default value is 314572800(300MB).

name

string

pattern: ^[A-Za-z0-9-._]{1,64}$

The name that identifies this endpoint. The name can only include alphanumeric characters, periods, underscores, hyphens and has a maximum length of 64 characters. The following names are reserved: events, fileNotifications, $default. Endpoint names must be unique across endpoint types.

resourceGroup

string

The name of the resource group of the storage account.

subscriptionId

string

The subscription identifier of the storage account.

RoutingStorageContainerPropertiesEncoding

Encoding that is used to serialize messages to blobs. Supported values are 'avro', 'avrodeflate', and 'JSON'. Default value is 'avro'.

Value Description
Avro

Avro

AvroDeflate

AvroDeflate

JSON

JSON

SharedAccessSignatureAuthorizationRule

The properties of an IoT hub shared access policy.

Name Type Description
keyName

string

The name of the shared access policy.

primaryKey

string

The primary key.

rights

AccessRights

The permissions assigned to the shared access policy.

secondaryKey

string

The secondary key.

StorageEndpointProperties

The properties of the Azure Storage endpoint for file upload.

Name Type Description
authenticationType

AuthenticationType

Specifies authentication type being used for connecting to the storage account.

connectionString

string

The connection string for the Azure Storage account to which files are uploaded.

containerName

string

The name of the root container where you upload files. The container need not exist but should be creatable using the connectionString specified.

identity

ManagedIdentity

Managed identity properties of storage endpoint for file upload.

sasTtlAsIso8601

string (duration)

The period of time for which the SAS URI generated by IoT Hub for file upload is valid. See: https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-file-upload#file-upload-notification-configuration-options.

systemData

Metadata pertaining to creation and last modification of the resource.

Name Type Description
createdAt

string (date-time)

The timestamp of resource creation (UTC).

createdBy

string

The identity that created the resource.

createdByType

createdByType

The type of identity that created the resource.

lastModifiedAt

string (date-time)

The timestamp of resource last modification (UTC)

lastModifiedBy

string

The identity that last modified the resource.

lastModifiedByType

createdByType

The type of identity that last modified the resource.